#include "stdafx.h"
#include "resource.h"
#include <aygshell.h>						// vibrate.hG[ɂȂ̂ō폜
#include <commctrl.h>
#include <windowsx.h>
#include <commdlg.h>

// Pixie.cpp
extern LPTSTR DoGetClipboard(HWND hWnd);
extern BOOL DoSetClipboard(HWND hWnd, TCHAR szStr[]);
extern BOOL GetOpenFileNameEx(OPENFILENAME* pofn);
extern INT DoGetFileName(HWND hWnd, LPTSTR szFileName, INT nMax, LPTSTR szOpenFilter);

// winlist.cpp
void WldSetBuffer(LPTSTR pBuf);
BOOL CALLBACK WinlistDlgFunc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

extern HINSTANCE		g_hInst;					// The current instance
extern HWND				hWndMain;
extern HWND				hWndEdit;

static HWND				hWndBrk;

static TCHAR			szLineBuf[ITEMSIZE_MAX*2];
static TCHAR			szItemList[ITEMLIST_MAX][2][ITEMSIZE_MAX] = {
	{_T("1 EChE̎擾..."),	_T("%A")},
	{_T("2 tpX̎擾..."),		_T("%P")},
	{_T("3 Nbv{[h"),		_T("%C")},
	{_T("4 ۊ()"),					_T("()")},
	{_T("5 p[]"),					_T("[]")},
	{_T("6 g{}"),					_T("{}")},
	{_T("7 ʁuv"),				_T("uv")},
	{_T("8 \\s"),					_T("\\\\n")},
	{_T("9 \\^bv"),					_T("\\\\T010010")},
	{_T("10 \\x"),					_T("\\\\W")},
	{_T("11 \\"),						_T("\\\\U")},
	{_T("12 \\"),						_T("\\\\D")},
	{_T("13 \\"),						_T("\\\\L")},
	{_T("14 \\E"),						_T("\\\\R")},
	{_T("15 ɂ"),				_T("ɂ")},
	{_T("16 ܂"),					_T("܂")},
	{_T("17 ()"),						_T("()")},
	{_T("18 ()"),						_T("()")},
	{_T("19 ()"),						_T("()")},
	{_T("20 orz"),						_T("orz")},
	{_T("21 (^^)"),						_T("(^^)")},
	{_T("22 (^^;"),						_T("(^^;")},
	{_T("23 ( --)/(;'')"),				_T("( --)/(;'')")},
	{_T("24 (^_^ )"),					_T("(^_^ )")},
	{_T("25 (*^^)l(*^-^*)l(^^*)"),	_T("(*^^)l(*^-^*)l(^^*)")},
	{NULL,NULL},
};


struct DLGITEM_T {
	int id;
	int left;
	int top;
	int right;
	int bottom;
};
static int iDlgItemId[] = {
	IDC_LIST_BRACKETS,
	IDCANCEL,
	IDOK,
	IDC_BTN_OPEN,
	-1
};


// tpX擾
static LPTSTR SelectFullpath(HWND hWnd, LPTSTR pBuf, size_t nSiz)
{
	TCHAR szFname[MAX_PATH] = _T("");
	if (DoGetFileName(hWnd, szFname, MAX_PATH, _T("ׂẴt@C (*.*)\0*.*"))) {
		_tcsncpy(pBuf, szFname, nSiz);
		pBuf[nSiz-1] = 0;
		return pBuf;
	}
	return NULL;
}

// obt@AhX̎擾
LPTSTR BrkGetLineBuf(void)
{
	return szLineBuf;
}

// ̉
int BrkDecodeItem(HWND hWnd, LPTSTR pOut, size_t nSiz, LPTSTR pIn)
{
	while (*pIn) {
		if (*pIn == _T('%')) {
			pIn++;
			if (*pIn == _T('P')) {			// tpX̎擾
				pIn++;
				TCHAR szFname[MAX_PATH] = _T("");
				size_t len;
				if (SelectFullpath(hWnd, szFname, ARRAY_SIZE(szFname))) {
					len = _tcslen(szFname);
					if (nSiz > len) {
						_tcscpy(pOut, szFname);
						pOut += len;
						nSiz -= len;
					} else {
						len = nSiz-1;
						_tcsncpy(pOut, szFname, len);
						pOut += len;
						nSiz  = 0;
					}
				}
			} else if (*pIn == _T('A')) {	// EChENXE^Cg
				pIn++;
				TCHAR szWinInfo[256] = _T("");
				size_t len;
				WldSetBuffer(szWinInfo);
				DialogBox(g_hInst, MAKEINTRESOURCE(IDD_DIALOG_WINLIST), NULL, (DLGPROC)WinlistDlgFunc);
				if (szWinInfo[0]) {
					len = _tcslen(szWinInfo);
					if (nSiz > len) {
						_tcscpy(pOut, szWinInfo);
						pOut += len;
						nSiz -= len;
					} else {
						len = nSiz-1;
						_tcsncpy(pOut, szWinInfo, len);
						pOut += len;
						nSiz  = 0;
					}
				}
			} else if (*pIn == _T('C')) {	// Nbv{[h
				pIn++;
				LPTSTR ptr = DoGetClipboard(hWndMain);
				if (ptr) {
					size_t len = _tcslen(ptr);
					if (nSiz > len) {
						_tcscpy(pOut, ptr);
						pOut += len;
						nSiz -= len;
					} else {
						len = nSiz-1;
						_tcsncpy(pOut, ptr, len);
						pOut += len;
						nSiz  = 0;
					}
				}
			} else {						// `͂̂̕܂܎g(%%->%)
				*pOut++ = *pIn++;
				nSiz--;
			}
		} else {							// ϐȊO̕
			*pOut++ = *pIn++;
			nSiz--;
		}

		if (!nSiz) break;
	}
	*pOut = 0;
	return 0;
}

// Xgւ̕ݒ
static int SetListText(HWND hWnd)
{
	int n;

	SendDlgItemMessage(hWnd, IDC_LIST_BRACKETS, WM_SETREDRAW, FALSE, 0L);
	SendDlgItemMessage(hWnd, IDC_LIST_BRACKETS, LB_RESETCONTENT, 0, 0L);
	for (n=0; szItemList[n][0][0]; n++) {
		SendDlgItemMessage(hWnd, IDC_LIST_BRACKETS, LB_ADDSTRING, 0, (LPARAM)(LPSTR)szItemList[n][0]);
	}
	SendDlgItemMessage(hWnd, IDC_LIST_BRACKETS, WM_SETREDRAW, TRUE, 0L);
	return 0;
}

// ̋L
static int SetBufferText(LPTSTR pBuff)
{
	int n;
	LPTSTR p;
	LPTSTR ep;

	n = 0;
	p = pBuff; 
	while (p) {
		ep = wcsstr(p, _T("\r\n"));
		if (ep == NULL) break;
		*ep = 0;
		wcsncpy(szItemList[n][0], p, sizeof(szItemList[n][0]));
		p = ep + 2;
		ep = wcsstr(p, _T("\r\n\r\n"));
		*ep = 0;
		wcsncpy(szItemList[n][1], p, sizeof(szItemList[n][1]));
		p = ep + 4;
		n++;
		if (n >= ITEMLIST_MAX-1) break;
	}
	szItemList[n][0][0] = szItemList[n][1][0] = 0;
	return 0;
}

// t@Cǂݍ
BOOL ReadFileFreeWord(HWND hWnd, LPTSTR szFileName)
{
	HANDLE hFile;
	DWORD nFileSizeMb;
	DWORD nCnt;										// ǂݏof[^
	BOOL res = TRUE;
	//TCHAR szStr[128];
	LPSTR pWorkMb;
	LPTSTR pBuffWc;
	UINT nLenWc;
	HICON hiconIcon;

	hFile = CreateFile(szFileName, GENERIC_READ | GENERIC_WRITE,
						FILE_SHARE_READ, NULL, OPEN_EXISTING, 
						FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE) {
		//wsprintf(szStr, TEXT("%s ܂."), szFileName);
		//MessageBox(hWnd, szStr, TEXT("error"), MB_OK);
		return FALSE;
	}
	nFileSizeMb = GetFileSize(hFile, NULL);				// t@CTCY擾
	pWorkMb = (LPSTR)LocalAlloc(LPTR, nFileSizeMb+1);	// Ǐom
	if (pWorkMb == NULL) {								// mۂłȂ΃G[
		MessageBox(hWnd, TEXT("mۂł܂ł(1)"), TEXT("error"), MB_OK);
		return FALSE;
	}

	hiconIcon = LoadCursor(NULL, IDC_WAIT);
	SetCursor(hiconIcon);

	ReadFile(hFile, pWorkMb, nFileSizeMb, &nCnt, NULL);
	CloseHandle(hFile);

	//wsprintf(szStr, TEXT("%d:%d byte"), nFileSize, nCnt);	//
	//MessageBox(hWnd, szStr, TEXT("debug"), MB_OK);			//

	if (nCnt != nFileSizeMb) {								// read NG
		MessageBox(hWnd, TEXT("t@CǍG[."), TEXT("error"), MB_OK);
		res = FALSE;

	} else {												// read OK
		nLenWc = MultiByteToWideChar(CP_ACP, 0, pWorkMb, -1, 0, 0);
		pBuffWc = (LPTSTR)LocalAlloc(LPTR, nLenWc*sizeof(TCHAR));	// UNICODEDϊm
		if (pBuffWc == NULL) {								// mۂłȂ΃G[
			MessageBox(hWnd, TEXT("mۂł܂ł(2)."), TEXT("error"), MB_OK);
			res = FALSE;

		} else {											// mۂł΃R[hϊ
			MultiByteToWideChar(CP_ACP, 0, pWorkMb, -1, pBuffWc, nLenWc);
			SetBufferText(pBuffWc);
			LocalFree(pBuffWc);
		}
	}

	SetCursor(0);
	LocalFree(pWorkMb);
	return res;
}

// J
static void DoOpenFileFreeWord(HWND hWnd)
{
	static TCHAR szFilter[] = 
		TEXT("ׂẴt@C (*.*)\0*.*\0\0");
	TCHAR szFname[MAX_PATH] = TEXT("");

	szFname[0] = 0;
	if (DoGetFileName(hWnd, szFname, MAX_PATH, szFilter)) {
		ReadFileFreeWord(hWnd, szFname);
		SetListText(hWnd);
	}
}

// WM_INITDIALOG
static BOOL DoInitDialogBrackets(HWND hDlg)
{
	RECT rt1, rt;
	int Width, Height;
	int i;
	int w, h, x, y;
	HWND hWndItem;

	GetClientRect(hDlg, &rt1);
	Width	= (rt1.right - rt1.left) - 4;
	Height	= (rt1.bottom - rt1.top) - 4;

	for (i=1; iDlgItemId[i] != -1; i++) {
		hWndItem = GetDlgItem(hDlg, iDlgItemId[i]);
		GetClientRect(hWndItem, &rt);
		w = rt.right  - rt.left;
		h = rt.bottom - rt.top;
		x = rt1.right - w*i - 2;
		y = rt1.bottom - h - 2;
		SetWindowPos(hWndItem, 0, x, y, w, h, SWP_NOZORDER | SWP_NOSIZE);
	}

	x = 2;
	y = 2;
	SetWindowPos(GetDlgItem(hDlg, IDC_LIST_BRACKETS), 0, x, y, Width, Height - h - 2, SWP_NOZORDER);

	SetListText(hDlg);

	return TRUE;
}

// XgRg[
static WNDPROC OldProc;
LRESULT CALLBACK BrkListProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static int iFlgEnter = -1;

	switch (message) {
	case WM_KEYUP:
		switch (LOWORD(wParam)) {
		case VK_RETURN:
			iFlgEnter++;
			if (iFlgEnter > 0) {
				SendMessage(hWndBrk, WM_COMMAND, IDOK, (LPARAM)0);
				iFlgEnter = -1;
				return TRUE;
			}
			break;
		case 0x0086:		// ANV{^̎VK_RETURNƈꏏɔ
			break;
		default:
			iFlgEnter = 0;
			break;
		}
		break;
	}

	return CallWindowProc(OldProc, hWnd, message, wParam, lParam);
}

// I_CAO
LRESULT CALLBACK DlgBrackets(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	SHINITDLGINFO shidi;
	int n;

	switch (message)
	{
		case WM_INITDIALOG:
			hWndBrk = hDlg;
			shidi.dwMask = SHIDIM_FLAGS;
			shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
			shidi.hDlg = hDlg;
			SHInitDialog(&shidi);
			SetForegroundWindow(hDlg);
			DoInitDialogBrackets(hDlg);
			OldProc = (WNDPROC)SetWindowLong(GetDlgItem(hDlg, IDC_LIST_BRACKETS), GWL_WNDPROC, (LONG)BrkListProc);
			return TRUE;

		case WM_DESTROY:
			(WNDPROC)SetWindowLong(GetDlgItem(hDlg, IDC_LIST_BRACKETS), GWL_WNDPROC, (LONG)OldProc);
			return TRUE; 

		case WM_COMMAND:
			switch ( GET_WM_COMMAND_ID(wParam, lParam) ) {
			case IDC_BTN_OPEN:
				DoOpenFileFreeWord(hDlg);
				ShowWindow(GetDlgItem(hDlg, IDC_LIST_BRACKETS), SW_SHOW);
				ShowWindow(hDlg, SW_SHOW);
				break;
			case IDOK:
				n = (int)SendDlgItemMessage(hDlg, IDC_LIST_BRACKETS, LB_GETCURSEL, 0, 0L);
				if (n >= 0) {
					// ϐ̓WJ
					BrkDecodeItem(hDlg, szLineBuf, ARRAY_SIZE(szLineBuf), szItemList[n][1]);
					// J[\ʒu֑}ꍇ͂
					DoSetClipboard(hDlg, szLineBuf);
					SendMessage(hWndEdit, WM_PASTE, 0, 0);
					// ꊷꍇ͂
					//SendMessage(hWndEdit, WM_SETTEXT, ARRAY_SIZE(szLineBuf), (LPARAM)szLineBuf);
				}
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;

			case IDCANCEL:
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}
