// setting.cpp : Setting S
//

#include "stdafx.h"
#include "resource.h"
#include <commctrl.h>
#include <aygshell.h>
#include <sipapi.h>
#include <commdlg.h>
#include <string.h>
#include "setting.h"

extern HWND		hWndMain;


struct setting_t {
	POINT    ptWin;							// JnW
	TCHAR    szDataPath[MAX_PATH];			// Œ蕶t@CpX
	UINT     uFlags;						// IvVݒ
	TCHAR    szSaveText[2][ITEMSIZE_MAX];	// g[t{^
};
static struct	setting_t stSetting = {
	{0,20},									// JnW
	_T("Pixie.dat"),						// Œ蕶t@CpX
	0,										// IvVݒ
	{ _T(""), _T("") }						// g[t{^
};

static struct setting_t stWork;
static bool blSetting = false;

static TCHAR	szIniName[256] = _T("Pixie.ini");

// init@C̃L[[h
// UNICODEł͂ȂƂɒ
static char*	szIniKeyWord[] = {
	"[PIXIE]",					// 0
	"X",						// 1 JnWX
	"Y",						// 2 JnWY
	"DataFile",					// 3 Œ蕶t@CpX
	"SendByEnter",				// 4 EnterL[őM
	"EndAfterSend",				// 5 MI
	"Tofu1",					// 6 g[t{^1
	"Tofu2",					// 7 g[t{^2
	""
};

// init@C̐ݒ
void StIniName(LPTSTR pPath)
{
	if (pPath) {
		wcsncpy(szIniName, pPath, sizeof(szIniName)/sizeof(TCHAR));
	}
}

// IvVݒ擾
// return == 0 : OFF / != 0 : ON
UINT StGetOption(UINT sw)
{
	return (stSetting.uFlags & sw);
}

// IvVݒ
// flag == PXI_OPT_xxx
// sw == 0 : OFF / != 0 : ON
UINT StSetOption(UINT flag, UINT sw)
{
	if (sw)	stSetting.uFlags |= flag;
	else	stSetting.uFlags &= ~flag;
	return stSetting.uFlags;
}

// \ʒu̐ݒ
void StPushWinwodPos(POINT *pt)
{
	stSetting.ptWin.x = pt->x;
	stSetting.ptWin.y = pt->y;
}

// \ʒu̎擾
void StPopWinwodPos(POINT *pt)
{
	pt->x = stSetting.ptWin.x;
	pt->y = stSetting.ptWin.y;
}

// f[^pXݒ
LPTSTR StSetDataPath(LPTSTR newpath)
{
	if (newpath) {
		lstrcpy(stSetting.szDataPath, newpath);
	}
	return stSetting.szDataPath;
}

// f[^pX擾
LPTSTR StGetDataPath(void)
{
	if (stSetting.szDataPath[0]) {
		return stSetting.szDataPath;
	}
	return NULL;
}

// g[tݒ
LPTSTR StSetSaveText(LPTSTR newpath, int no)
{
	if (no < 2) {
		if (newpath[0]) {
			lstrcpy(stSetting.szSaveText[no], newpath);
		}
	}
	return stSetting.szSaveText[no];
}

// g[t擾
LPTSTR StGetSaveText(int no)
{
	if (no < 2) {
		if (stSetting.szSaveText[no][0]) {
			return stSetting.szSaveText[no];
		}
	}
	return NULL;
}

// f[^Ǐo
void StLoadData(void)
{
	char sWork[2048];			// ő512B̃t@C
	HANDLE hFile;
	DWORD nCnt;					// ǂݏof[^
	char* ptr;

	// datt@CI[v
	hFile = CreateFile(szIniName, GENERIC_READ | GENERIC_WRITE,
						FILE_SHARE_READ, NULL, OPEN_EXISTING, 
						FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE) {
		//MessageBox(hWndMain, TEXT("ݒt@CI[vł܂."), TEXT("debug"), MB_OK);
		return;
	}

	ReadFile(hFile, sWork, sizeof(sWork), &nCnt, NULL);

	CloseHandle(hFile);

	ptr = strtok(sWork, "\r");
	if (strcmp(ptr, szIniKeyWord[0])) {
		return;
	}

	while (*ptr) {
		ptr = strtok(NULL, "=");
		if (ptr == 0) break;
		ptr++;

		if (strcmp(ptr, szIniKeyWord[1]) == 0) {
			ptr = strtok(NULL, "\r");
			stSetting.ptWin.x     = strtoul(ptr, NULL, 10);
			continue;
		}
		if (strcmp(ptr, szIniKeyWord[2]) == 0) {
			ptr = strtok(NULL, "\r");
			stSetting.ptWin.y     = strtoul(ptr, NULL, 10);
			continue;
		}
		if (strcmp(ptr, szIniKeyWord[3]) == 0) {
			LPSTR  pWorkMb = strtok(NULL, "\r");
			UINT   nLenWc  = MultiByteToWideChar(CP_ACP, 0, pWorkMb, -1, 0, 0);
			LPTSTR pBuffWc = stSetting.szDataPath;
			MultiByteToWideChar(CP_ACP, 0, pWorkMb, -1, pBuffWc, nLenWc);
			continue;
		}
		if (strcmp(ptr, szIniKeyWord[4]) == 0) {
			ptr = strtok(NULL, "\r");
			if (strtoul(ptr, NULL, 10)) {
				stSetting.uFlags |= PXI_OPT_SENDBYENTER;
			} else {
				stSetting.uFlags &= ~PXI_OPT_SENDBYENTER;
			}
			continue;
		}
		if (strcmp(ptr, szIniKeyWord[5]) == 0) {
			ptr = strtok(NULL, "\r");
			if (strtoul(ptr, NULL, 10)) {
				stSetting.uFlags |= PXI_OPT_ENDAFTERSEND;
			} else {
				stSetting.uFlags &= ~PXI_OPT_ENDAFTERSEND;
			}
			continue;
		}
		if (strcmp(ptr, szIniKeyWord[6]) == 0) {
			LPSTR  pWorkMb = strtok(NULL, "\r");
			UINT   nLenWc  = MultiByteToWideChar(CP_ACP, 0, pWorkMb, -1, 0, 0);
			LPTSTR pBuffWc = stSetting.szSaveText[0];
			MultiByteToWideChar(CP_ACP, 0, pWorkMb, -1, pBuffWc, nLenWc);
			continue;
		}
		if (strcmp(ptr, szIniKeyWord[7]) == 0) {
			LPSTR  pWorkMb = strtok(NULL, "\r");
			UINT   nLenWc  = MultiByteToWideChar(CP_ACP, 0, pWorkMb, -1, 0, 0);
			LPTSTR pBuffWc = stSetting.szSaveText[1];
			MultiByteToWideChar(CP_ACP, 0, pWorkMb, -1, pBuffWc, nLenWc);
			continue;
		}
	}

	blSetting = true;
}

// f[^ۑ
void StSaveData(void)
{
	char sWork[2048];
	HANDLE hFile;
	DWORD wtlen;
	int i;
	int j;

	// datt@C쐬
	hFile = CreateFile( szIniName, 
						GENERIC_READ | GENERIC_WRITE,
						FILE_SHARE_READ, NULL, CREATE_ALWAYS, 
						FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE) {
		MessageBox(hWndMain, TEXT("ݒt@C쐬ł܂."), TEXT("debug"), MB_OK);
		return;
	}

	i = 0;
	sprintf(sWork, "%s\r\n", szIniKeyWord[i]);
	WriteFile(hFile, sWork, strlen(sWork), &wtlen, NULL);
	i++;
	sprintf(sWork, "%s=%ld\r\n", szIniKeyWord[i],  stSetting.ptWin.x);
	WriteFile(hFile, sWork, strlen(sWork), &wtlen, NULL);
	i++;
	sprintf(sWork, "%s=%ld\r\n", szIniKeyWord[i],  stSetting.ptWin.y);
	WriteFile(hFile, sWork, strlen(sWork), &wtlen, NULL);
	i++;
	LPTSTR pReadWc = stSetting.szDataPath;
	DWORD nTextLenWc = wcslen(stSetting.szDataPath);
	char szWriteMb[MAX_PATH*2];
	UINT nLenMb = WideCharToMultiByte(CP_ACP, 0, pReadWc, nTextLenWc, NULL, 0, NULL, NULL);
	WideCharToMultiByte(CP_ACP, 0, pReadWc, nTextLenWc, szWriteMb, nLenMb+1, NULL, NULL);
	szWriteMb[nLenMb] = 0;
	sprintf(sWork, "%s=%s\r\n", szIniKeyWord[i], szWriteMb);
	WriteFile(hFile, sWork, strlen(sWork), &wtlen, NULL);
	i++;
	sprintf(sWork, "%s=%d\r\n", szIniKeyWord[i],  (stSetting.uFlags & PXI_OPT_SENDBYENTER)? 1: 0 );
	WriteFile(hFile, sWork, strlen(sWork), &wtlen, NULL);
	i++;
	sprintf(sWork, "%s=%d\r\n", szIniKeyWord[i],  (stSetting.uFlags & PXI_OPT_ENDAFTERSEND)? 1: 0 );
	WriteFile(hFile, sWork, strlen(sWork), &wtlen, NULL);
	i++;

	char szItemMb[ITEMSIZE_MAX*2];
	for (j=0; j<2; j++) {
		pReadWc = stSetting.szSaveText[j];
		if (pReadWc[0]) {
			nTextLenWc = wcslen(stSetting.szSaveText[j]);
			nLenMb = WideCharToMultiByte(CP_ACP, 0, pReadWc, nTextLenWc, NULL, 0, NULL, NULL);
			WideCharToMultiByte(CP_ACP, 0, pReadWc, nTextLenWc, szItemMb, nLenMb+1, NULL, NULL);
			szItemMb[nLenMb] = 0;
			sprintf(sWork, "%s=%s\r\n", szIniKeyWord[i], szItemMb);
			WriteFile(hFile, sWork, strlen(sWork), &wtlen, NULL);
		}
		i++;
	}

	CloseHandle(hFile);
	blSetting = true;
}

//-----------------------------------------------------------------------------------------
// tpX}
static int StSelectFullpath(HWND hDlg)
{
	extern INT DoGetFileName(HWND hWnd, LPTSTR szFileName, INT nMax, LPTSTR szOpenFilter);

	TCHAR szFname[MAX_PATH] = TEXT("");
	if (DoGetFileName(hDlg, szFname, MAX_PATH, TEXT("ׂẴt@C (*.*)\0*.*"))) {
		SetWindowText(GetDlgItem(hDlg, IDC_EDIT_DATAPATH), szFname);
	}
	return 0;
}

// f[^擾
static void StGetData(HWND hDlg)
{
	if (SendMessage(GetDlgItem(hDlg, IDC_CHK_SENDBYENTER), BM_GETCHECK, 0, 0) == BST_CHECKED) {
		stWork.uFlags |= PXI_OPT_SENDBYENTER;
	} else {
		stWork.uFlags &= ~PXI_OPT_SENDBYENTER;
	}
	if (SendMessage(GetDlgItem(hDlg, IDC_CHK_ENDAFTERSEND), BM_GETCHECK, 0, 0) == BST_CHECKED) {
		stWork.uFlags |= PXI_OPT_ENDAFTERSEND;
	} else {
		stWork.uFlags &= ~PXI_OPT_ENDAFTERSEND;
	}
	GetWindowText(GetDlgItem(hDlg, IDC_EDIT_DATAPATH), stWork.szDataPath, sizeof(stWork.szDataPath)/sizeof(TCHAR));
}

// XV
static void StUpdate(HWND hDlg)
{
	if (stWork.uFlags & PXI_OPT_SENDBYENTER) {
		SendMessage(GetDlgItem(hDlg, IDC_CHK_SENDBYENTER), BM_SETCHECK, BST_CHECKED, 0);
	} else {
		SendMessage(GetDlgItem(hDlg, IDC_CHK_SENDBYENTER), BM_SETCHECK, BST_UNCHECKED, 0);
	}
	if (stWork.uFlags & PXI_OPT_ENDAFTERSEND) {
		SendMessage(GetDlgItem(hDlg, IDC_CHK_ENDAFTERSEND), BM_SETCHECK, BST_CHECKED, 0);
	} else {
		SendMessage(GetDlgItem(hDlg, IDC_CHK_ENDAFTERSEND), BM_SETCHECK, BST_UNCHECKED, 0);
	}
	SetWindowText(GetDlgItem(hDlg, IDC_EDIT_DATAPATH), stWork.szDataPath);
}

// 
static void StInitialize(HWND hDlg)
{
	//stSetting.ptWin.x = 0;	// JnW
	//stSetting.ptWin.y = 20;
	//wcscpy(stSetting.szDataPath, _T("Pixie.dat"));	// Œ蕶t@CpX
	//stSetting.uFlags  = 0;	// IvVݒ
	//StLoadData();

	RECT rt1;
	int DlgWidth, DlgHeight;	// sNZPʂł̃_CAO̕ƍ
	int NewPosX, NewPosY;

	if (GetWindowRect(hDlg, &rt1)) {
		DlgWidth	= rt1.right - rt1.left;
		DlgHeight	= rt1.bottom - rt1.top ;
		NewPosX		= (GetSystemMetrics(SM_CXSCREEN) - DlgWidth)/2;
		NewPosY		= (GetSystemMetrics(SM_CYSCREEN) - DlgHeight)/2;
		// ʂ傫ꍇ 
		if (NewPosX < 0) NewPosX = 0;
		if (NewPosY < 0) NewPosY = 40;
		SetWindowPos(hDlg, 0, NewPosX, NewPosY,
			0, 0, SWP_NOZORDER | SWP_NOSIZE);
	}
	stWork = stSetting;
	StUpdate(hDlg);
	SetForegroundWindow(hDlg);
}

// Iݒ
static void StEnd(HWND hDlg)
{
	extern BOOL ReadFileFreeWord(HWND hWnd, LPTSTR szFileName);

	StGetData(hDlg);
	if (memcmp(&stSetting, &stWork, sizeof(struct setting_t)) != 0) {
		if (_tcscmp(stSetting.szDataPath, stWork.szDataPath)) {	// sv
			ReadFileFreeWord(hDlg, stWork.szDataPath);
		}
		stSetting = stWork;
		StSaveData();
	}
}

// ݒ_CAO
LRESULT CALLBACK DlgSetting(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
			StInitialize(hDlg);
			return TRUE;

		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
				case IDOK:
					StEnd(hDlg);
					EndDialog(hDlg, 1);
					return TRUE;

				case IDCANCEL:
					EndDialog(hDlg, 0);
					return TRUE;

				case IDC_BTN_DATAPATH:
					StSelectFullpath(hDlg);
					return TRUE;

				case IDC_CHK_SENDBYENTER:
				case IDC_CHK_ENDAFTERSEND:
				case IDC_EDIT_DATAPATH:
					switch (HIWORD(wParam)) {
					case EN_KILLFOCUS:
						StGetData(hDlg);
						break;
					}
					return TRUE;
			}
			break;
	}
    return FALSE;
}
//-----------------------------------------------------------------------------------------
